%global name mod_bw
%global version 0.92
%global rpmrelease 4

%global _shortname %(eval NAME=%{name} ; echo "${NAME/mod_}")
%global _has_old_httpd %(eval [ $(rpm -q --queryformat '%{VERSION}' httpd-devel | cut -d "." -f 2) -lt 4 ] && echo 1 || echo 0)
%global _httpd_apxs %(eval [ -x %{_sbindir}/apxs ] && echo %{_sbindir}/apxs || echo apxs)
%global _httpd_moddir %{_libdir}/httpd/modules
%global _httpd_confdir %{_sysconfdir}/httpd/conf.d
# only httpd >= 2.4 has /etc/httpd/conf.modules.d
%if ! %{_has_old_httpd}
%global _httpd_modconfdir %{_sysconfdir}/httpd/conf.modules.d
%endif

Summary: Bandwidth limiter for the Apache HTTP server
Name: %{name}
Version: %{version}
Release: %{rpmrelease}%{?dist}
License: ASL 2.0
Group: System Environment/Daemons
URL: http://legacy.ivn.cl/apache/
Packager: Simon Matter <simon.matter@invoca.ch>
Vendor: Invoca Systems
Distribution: Invoca Linux Server
Source0: http://legacy.ivn.cl/apache/files/source/%{name}-%{version}.tgz
Source1: %{name}-0.92.conf
Source2: %{name}-0.92.mod.conf
Patch0: %{name}-httpd24.patch
%if %{_has_old_httpd}
Requires: httpd >= 2.0.0
%else
Requires: httpd >= 2.4.0
%endif
BuildRequires: httpd-devel
BuildRoot: %{_tmppath}/%{name}-%{version}-root

%description
The Apache HTTPD module %{name} allows to control bandwidth for the Apache
HTTP server. It can restrict the number of simultaneous connections
per vhost/dir and also limit the bandwidth for files on vhost/dir.

%prep
%setup -q -c
%if ! %{_has_old_httpd}
%patch0 -p1 -b .httpd24
%endif

%build
%{_httpd_apxs} -c %{name}.c

%install
[ "%{buildroot}" != "/" ] && %{__rm} -rf %{buildroot}

%{__install} -d %{buildroot}%{_httpd_moddir}
%{__install} -d %{buildroot}%{_httpd_confdir}
%if ! %{_has_old_httpd}
%{__install} -d %{buildroot}%{_httpd_modconfdir}
%endif

%{__install} -m 0755 -p .libs/%{name}.so %{buildroot}%{_httpd_moddir}/
%if ! %{_has_old_httpd}
%{__install} -m 0644 -p %{SOURCE1} %{buildroot}%{_httpd_confdir}/%{_shortname}.conf
%{__install} -m 0644 -p %{SOURCE2} %{buildroot}%{_httpd_modconfdir}/10-%{_shortname}.conf
%else
# merge configs for httpd < 2.4
{ %{__cat} %{SOURCE2}
  echo
  %{__cat} %{SOURCE1}
} > merged.conf
touch -c -r %{SOURCE1} merged.conf
%{__install} -m 0644 -p merged.conf %{buildroot}%{_httpd_confdir}/%{_shortname}.conf
%endif

%clean
[ "%{buildroot}" != "/" ] && %{__rm} -rf %{buildroot}

%files
%defattr(-,root,root,-)
%doc ChangeLog LICENSE TODO mod_bw.txt
%{_httpd_moddir}/%{name}.so
%config(noreplace) %{_httpd_confdir}/%{_shortname}.conf
%if ! %{_has_old_httpd}
%config(noreplace) %{_httpd_modconfdir}/10-%{_shortname}.conf
%endif

%changelog
* Wed Apr 22 2020 Simon Matter <simon.matter@invoca.ch> 0.92-4
- add support for EL8

* Fri May 25 2018 Simon Matter <simon.matter@invoca.ch> 0.92-3
- split config for httpd >= 2.4

* Tue Dec 16 2014 Simon Matter <simon.matter@invoca.ch> 0.92-2
- make it build on el7

* Wed Apr 20 2011 Simon Matter <simon.matter@invoca.ch> 0.92-1
- upgrade to 0.92

* Fri Apr 15 2011 Simon Matter <simon.matter@invoca.ch> 0.8-2
- mass rebuild

* Fri Aug 17 2007 Simon Matter <simon.matter@invoca.ch> 0.8-1
- initial package
